#include <bicoti.hpp>

/* Ejemplos de construccin de implementaciones de imgenes y copia entre ellas */

main() 
{ 
  cout << " Comenzaremos por ejemplificar como debe declararse una implementacin" << endl;
  cout << "de imagen. En nuestro ejemplo usaremos imgenes 2D con implementacin" << endl;
  cout << "Array y dos tipos de pixeles distintos. En concreto" << endl << endl;

  cout << "\t bicotiImageImplementation2DArray< int > * ptr_ima1;" << endl;
  cout << "\t bicotiImageImplementation2DArray< float > * ptr_ima2;" << endl;
  cout << "\t ptr_ima1 = new bicotiImageImplementation2DArray< int >( 0, 5, 4 );" << endl;
  cout << "\t ptr_ima2 = new bicotiImageImplementation2DArray< float >( 0, 5, 4 );" << endl << endl;

  bicotiImageImplementation2DArray< int > * ptr_ima1; 
  bicotiImageImplementation2DArray< float > * ptr_ima2; 
  ptr_ima1 = new bicotiImageImplementation2DArray< int >( 0, 5, 4 ); 
  ptr_ima2 = new bicotiImageImplementation2DArray< float >( 0, 5, 4 ); 
  
  cout << " En el ejemplo ptr_ima1 es un puntero a una implementacin 2D Array" << endl;
  cout << "con pixeles de tipo int. Mientras que ptr_ima2 es 2D Array con pixeles float." << endl;
  cout << " Ambas implementaciones son de 5 columnas, 4 filas y en principio estn llenas de ceros." << endl << endl;
  
  cout << "PRESIONE ENTER PARA CONTINUAR" << endl;
  cin.get(); 
  cout << endl;
  cout << "_________________________________________________________________" << endl << endl;
  cout << " Brevemente mostraremos como Setear y Leer pixeles en la imagen." << endl;
  cout << " Setearemos los pixeles (0,2) (1,1) y (3,3) de ptr_ima1 con 1, 2 y 3 repectivamente." << endl << endl;
  cout << "\t ptr_ima1->SetPixel( 0, 2, 1 );" << endl;
  cout << "\t ptr_ima1->SetPixel( 1, 1, 2 );" << endl;
  cout << "\t ptr_ima1->SetPixel( 3, 3, 3 );" << endl << endl;

  ptr_ima1->SetPixel( 0, 2, 1 );
  ptr_ima1->SetPixel( 1, 1, 2 );
  ptr_ima1->SetPixel( 3, 3, 3 );

  cout << " Para ver como quedo la imagen ejecutaremos las siguientes lineas de cdigo" << endl << endl;
  cout << "\t unsigned i,j;" << endl;
  cout << "\t for( j=0; j<ptr_ima1->GetX1Size(); j++ )" << endl;
  cout << "\t  {for( i=0; i<ptr_ima1->GetX0Size(); i++ )" << endl;
  cout << "\t    cout << \" \" << ptr_ima1->GetPixel( i, j );" << endl;
  cout << "\t   cout << endl;}" << endl << endl;

  unsigned i,j;
  for( j = 0; j<ptr_ima1->GetX1Size(); j++ )
    {cout << ">> ";
    for( i = 0; i < ptr_ima1->GetX0Size(); i++ )
      cout << " " << ptr_ima1->GetPixel( i, j );
    cout << endl;}
  cout << endl;

  cout << " De aqu en ms usaremos imgenes reales para los ejemplos." << endl;
  cout << " Cabe aclarar que las funciones para visualizar imgenes no son parte" << endl;
  cout << "de nuestro proyecto. No se ha hecho esfuerzo en acerlas portables y solo" << endl;
  cout << "forman parte de este tutorial." << endl;
  cout << " Es importante recordar liberar la memoria al terminar." << endl << endl;

  cout << "\t delete ptr_ima1;" << endl;
  cout << "\t delete ptr_ima2;" << endl << endl;

  delete ptr_ima1; 
  delete ptr_ima2; 
} 
