#ifndef _bicoti_actor_graphic_2D_panel
#define _bicoti_actor_graphic_2D_panel


#include <source/actor/actor_graphic_2D.hpp>

//------------------bicotiActorGraphic2DPanel-----------------

/**
 * Proporciona un panel. 
 *
 * Un panel es un rea rectangular donde se pueden pegar otros actores grficos.
 *@see bicotiHomologousGraphic2DPanel
 */
class bicotiActorGraphic2DPanel : public bicotiActorGraphic2D
{
public:
  /**
   * Constructor
   *
   * Construye un nuevo bicotiActorGraphic2DPanel
   *@param act_name nombre del actor
   */
  bicotiActorGraphic2DPanel( char * act_name = NULL );

  /** Destructor */
  ~bicotiActorGraphic2DPanel();
};



//----------------bicotiHomologousGraphic2DPanel--------------

/** 
 * Homlogo para bicotiActorGraphic2DPanel 
 */
class bicotiHomologousGraphic2DPanel : public bicotiHomologousGraphic2D
{};

#endif
