#include <source/device/device_file.hpp>
#include <source/bicoti_basic.hpp>

//------------------IMPLEMENTATIONS--------------------
//------------------bicotiDeviceFile-------------------
bicotiDeviceFile :: bicotiDeviceFile( char * name )
{strcpy( file_name, name );
 ptr_file = NULL;}

void bicotiDeviceFile :: SetFileName( const char * name )
{
  Close();
  strcpy( file_name, name );
}

bicotiDeviceFile :: ~bicotiDeviceFile()
{Close();}


void bicotiDeviceFile :: Open( const char * mode )
{if( ptr_file == NULL ) 
  ptr_file = fopen( file_name, mode );
 else throw bicotiException(" DeviceFile " , " Open " , 7 );}


void bicotiDeviceFile :: Close()
{if( ptr_file != NULL )
  {fclose( ptr_file );
  ptr_file = NULL;}}


inline bool bicotiDeviceFile :: IsOpened()
{return ( ptr_file != NULL );}


long bicotiDeviceFile :: GetImageSize()
{long current_position, file_size = -1;
 if ( ptr_file != NULL )
   {current_position = ftell( ptr_file );
   fseek( ptr_file, SEEK_SET, SEEK_END);
   file_size = ftell( ptr_file );
   fseek( ptr_file, SEEK_SET, current_position );
   return( file_size );}
 else throw bicotiException(" DeviceFile " , " GetImageSize " , 8 );
}


int bicotiDeviceFile :: Get( char * blob )
{ int bc;
 bc = ( fread( blob, 1, block_size, ptr_file ) );
 if( bc > -1 )
   return bc;
 else throw bicotiException( " DeviceFile " , " Get " , 9 );}


void bicotiDeviceFile :: Put( const char * blob )
{int bc;
 if( block_size != fwrite( blob, 1, block_size, ptr_file ))
   throw bicotiException( " DeviceFile " , " Get " , 9 );} 

