#include <source/dexel/dexel_labeling/connectivity_labeling_strategy_2D_4N.hpp>


//******************************IMPLEMENTATIONS**********************************
//--------------------bicotiConnectivityLabelingStrategy2D4N---------------------
bicotiConnectivityLabelingStrategy2D4N :: bicotiConnectivityLabelingStrategy2D4N()
{
  next_label_available = 1;
  ptr_matrix = NULL;
};


void bicotiConnectivityLabelingStrategy2D4N :: operator() ( bicotiCoordinate< INTEGER > coord )
{
#ifdef TOTAL_CHECK
  if( coord.GetDimension() != 2 )
    throw bicotiException( "bicotiConnectivityLabelingStrategy2D4N", "operator()", 2 );
#endif

  current_x1 = (int)coord( 0 );
  current_x2 = (int)coord( 1 ); 

  if( InImage( current_x1, current_x2 - 1 ) && InImage( current_x1 - 1, current_x2 ) )
    {if( (*ptr_matrix)( current_x1, current_x2 - 1 ) == 0 )
      {if( (*ptr_matrix)( current_x1 - 1, current_x2 ) == 0 )
	{(*ptr_matrix)( current_x1, current_x2 ) = next_label_available;
	InsertInTable( next_label_available );
	next_label_available++;}
      else
	(*ptr_matrix)( current_x1, current_x2 ) = (*ptr_matrix)( current_x1 - 1, current_x2 );}
    else
      {if( (*ptr_matrix)( current_x1 - 1, current_x2 ) == 0 )
	(*ptr_matrix)( current_x1, current_x2 ) = (*ptr_matrix)( current_x1 , current_x2 - 1 );
      else
	{(*ptr_matrix)( current_x1, current_x2 ) = (*ptr_matrix)( current_x1 - 1, current_x2 );
	   SetEquivalence( (*ptr_matrix)( current_x1 , current_x2 - 1 ), (*ptr_matrix)( current_x1 - 1, current_x2 ) );}}}
  else
    {if( InImage( current_x1, current_x2 - 1 ) )
      {if( (*ptr_matrix)( current_x1, current_x2 - 1 ) != 0 )
	(*ptr_matrix)( current_x1, current_x2 ) = (*ptr_matrix)( current_x1 , current_x2 - 1 );
      else
	{(*ptr_matrix)( current_x1, current_x2 ) = next_label_available;
	InsertInTable( next_label_available );
	next_label_available++;}}
    else
      {if( InImage( current_x1 - 1, current_x2 ) )
	{if( (*ptr_matrix)( current_x1 - 1, current_x2 ) != 0 )
	  (*ptr_matrix)( current_x1, current_x2 ) = (*ptr_matrix)( current_x1 - 1, current_x2 );
	else
	  {(*ptr_matrix)( current_x1, current_x2 ) = next_label_available;
	  InsertInTable( next_label_available );
	  next_label_available++;}}
      else
	{(*ptr_matrix)( current_x1, current_x2 ) = next_label_available;
	InsertInTable( next_label_available );
	next_label_available++;}}}
};
