bicotiLocalTemplate
void bicotiLocalClass :: closeEvent( QCloseEvent * e )
{
  ((bicotiActorGraphic*)ptr_actor)->SetVisible( false );
  e->accept();
  if( ((bicotiActorGraphic*)ptr_actor)->GetMainActor() ) 
    if( ptr_actor->GetCurrentEventLoop() != NULL )
      ptr_actor->GetCurrentEventLoop()->Stop();
}

bicotiLocalTemplate
void bicotiLocalClass :: SetVisible( bool visible )
{
  if ( visible )
    show();
  else
    hide();
}


bicotiLocalTemplate
void bicotiLocalClass :: SetChild( bicotiHomologousGraphic * ptr_child )
{
  ptr_child->LoadConcreteInstance();
  QWidget * ptr_widget = bicotiHomologousQTCaster :: ptr_concrete_instance;
  ptr_widget->recreate( this, 0, ptr_widget->pos(), ((bicotiActorGraphic*)ptr_child->GetActor())->GetVisible() );
}

bicotiLocalTemplate
void bicotiLocalClass :: RemoveChild( bicotiHomologousGraphic * ptr_child )
{
  ptr_child->LoadConcreteInstance();
  QWidget * ptr_widget = bicotiHomologousQTCaster :: ptr_concrete_instance;
  ptr_widget->recreate( NULL, 0, ptr_widget->pos(), ((bicotiActorGraphic*)ptr_child->GetActor())->GetVisible() );
}

bicotiLocalTemplate
void bicotiLocalClass :: SetBackgroundColor( bicotiPixelRGBA color )
{
  setBackgroundColor( QColor( bicotiRGBTools :: GetRed( color ), bicotiRGBTools :: GetGreen( color ), bicotiRGBTools :: GetBlue( color ) ) );
}

bicotiLocalTemplate

void bicotiLocalClass :: SetForegroundColor( bicotiPixelRGBA color )
{
  //  setForegroundColor( QColor( bicotiRGBTools :: GetRed( color ), bicotiRGBTools :: GetGreen( color ), bicotiRGBTools :: GetBlue( color ) ) );
}

bicotiLocalTemplate
void bicotiLocalClass :: ActivateMouseMotionTracking()
{
  setMouseTracking( TRUE );
}

bicotiLocalTemplate
void bicotiLocalClass :: DeactivateMouseMotionTracking()
{
  setMouseTracking( FALSE );
}

bicotiLocalTemplate
void bicotiLocalClass :: SetFont( bicotiFont font )
{
  switch( font.GetType() )
    {case _helvetica:
      {strcpy( family, "Helvetica" );
      break;}
    case _times:
      {strcpy( family, "Times" );
      break;}
    case _courier:
      {strcpy( family, "Courier" );
      break;}
    case _old_english:
      {strcpy( family, "OldEnglish" );
      break;}
    case _system:
      {strcpy( family, "System" );
      break;}
    default:
      {strcpy( family, "Helvetica" );}
      break;}

  int weight = ( (font.GetStyle() & _bold) ? (QFont :: Bold) : (QFont :: Normal) );
  
  /*
  qfont.setBold( (font.GetStyle() & _bold) );
  qfont.setItalic( (font.GetStyle() & _italic) );
  qfont.setUnderline( (font.GetStyle() & _underline) );
  */
  setFont( QFont( family, font.GetSize(), weight, (font.GetStyle() & _italic) ) );

  /*
  QFont qfont;
  
  switch( font.GetType() )
    {case _helvetica:
      qfont.setFamily( "Helvetica" );
    case _times:
      qfont.setFamily( "Times" );
    case _courier:
      qfont.setFamily( "Courier" );
    case _old_english:
      qfont.setFamily( "OldEnglish" );
    case _system:
      qfont.setFamily( "System" );
    default:
      qfont.setFamily( "Helvetica" );}
  
  qfont.setWeight( font.GetSize() );

  qfont.setBold( font.GetStyle() & _bold );
  qfont.setItalic( font.GetStyle() & _italic );
  qfont.setUnderline( font.GetStyle() & _underline );

  setFont( qfont );
  */
}


bicotiLocalTemplate
void bicotiLocalClass :: LoadConcreteInstance()
{
  bicotiHomologousQTCaster :: ptr_concrete_instance = (bicotiLocalClass*)this;
}
