#ifndef _bicoti_homologous_qt_menu_bar
#define _bicoti_homologous_qt_menu_bar



#include <qmenubar.h>
#include <source/actor/actor_graphic_menu_bar.hpp>
#include <source/actor/actor_graphic_2D.hpp>
#include <source/event_loop_manager/qt/homologous_qt_menu_popup.hpp>
#include <source/event_loop_manager/qt/homologous_qt_caster.hpp>


//-----------------bicotiQT2DPushButton------------------

/** Implementacin QT de bicotiHomologousGraphicMenuBar */
class bicotiQTMenuBar :  public QMenuBar, public bicotiHomologousGraphicMenuBar
{
  /**@#-*/
Q_OBJECT
/**@#+*/

public /**@#-*/ slots /**@#+*/ :
  void Selected( int );

public:
  /** 
   *Constructor
   *
   *@param parent widget padre
   *@param name nombre del widget
   */ 
  bicotiQTMenuBar( QWidget * parent=0, const char * name=0 );
  
  /** Destructor */
  ~bicotiQTMenuBar();

#include <source/event_loop_manager/qt/homologous_qt_graphic.hpp>
#include <source/event_loop_manager/qt/homologous_qt_graphic_menu.hpp>
};


#endif
