#ifndef _bicoti_homologous_qt_timer
#define _bicoti_homologous_qt_timer


#include <qtimer.h>
#include <source/actor/actor_timer.hpp>

//-----------------bicotiQTTimer------------------

/** Implementacin QT de bicotiHomologousTimer */
class bicotiQTTimer :  public QTimer, public bicotiHomologousTimer
{
  
  /**@#-*/
Q_OBJECT
/**@#+*/

private /**@#-*/ slots /**@#+*/:

/** 
 * Este mtodo se ejecuta cuado pas un periodo
 *
 */ 
 void LocalTimeout();

public:
  
  /**
   * Constructor
   *
   */
  bicotiQTTimer();
  
  /** Destructor */
  ~bicotiQTTimer();

  /** 
   * Fija el periodo
   *
   *@param per periodo en milisegundos
   */
  void SetPeriod( int per );
};


#endif
