//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################




#ifndef _image_2D_array_rgb_char
#define _image_2D_array_rgb_char



#include <source/image/image_2D_vectorial.hpp>
#include <source/pixel/pixel_converter_rgba.hpp>



//**********************DECLARATIONS**************************
class bicotiImage2DArrayRGBChar : public bicotiImage2DVectorial< bicotiImageImplementation2DArray< bicotiRGB< unsigned char, REAL > >, unsigned char, bicotiPixelConverterRGBChar2RGBA, bicotiRGB< unsigned char, REAL >, bicotiRGB< REAL, unsigned char >  >
{
public:
  bicotiImage2DArrayRGBChar( unsigned, unsigned );
  bicotiImage2DArrayRGBChar();
  ~bicotiImage2DArrayRGBChar();

  void BuildImplementation( unsigned, unsigned );
  void BuildMapper();
};



#endif
