#include <source/image/image_2D_sparse_rgb_char.hpp>


//********************IMPLEMENTATIONS*************************
bicotiImage2DSparseRGBChar :: bicotiImage2DSparseRGBChar(unsigned x0_size, unsigned x1_size)
{
  ResetPointers();

  bicotiRGB< unsigned char, REAL > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation2DSparse< bicotiRGB< unsigned char, REAL > >( def_pix, x0_size, x1_size, 1, vectorial);
};


bicotiImage2DSparseRGBChar :: bicotiImage2DSparseRGBChar()
{
  ResetPointers();

  bicotiRGB< unsigned char, REAL > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation2DSparse< bicotiRGB< unsigned char, REAL > >( def_pix, 0, 0, 1, vectorial);
};


bicotiImage2DSparseRGBChar :: ~bicotiImage2DSparseRGBChar()
{
  DeleteMe();
};


void bicotiImage2DSparseRGBChar :: BuildImplementation( unsigned x0_size, unsigned x1_size )
{
  DeleteMe();

  bicotiRGB< unsigned char, REAL > def_pix(0,0,0);
  
  ptr_implementation = new bicotiImageImplementation2DSparse< bicotiRGB< unsigned char, REAL > >( def_pix, x0_size, x1_size, 1, vectorial );
};



