//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################




#ifndef _image_2D_sparse_rgb_char
#define _image_2D_sparse_rgb_char



#include <source/image/image_2D_vectorial.hpp>



//**********************DECLARATIONS**************************
class bicotiImage2DSparseRGBChar : public bicotiImage2DVectorial< bicotiImageImplementation2DSparse< bicotiRGB< unsigned char, REAL > >, unsigned char, bicotiRGB< unsigned char, REAL >, bicotiRGB< REAL, unsigned char >  >
{
public:
  bicotiImage2DSparseRGBChar( unsigned, unsigned );
  bicotiImage2DSparseRGBChar();
  ~bicotiImage2DSparseRGBChar();

  void BuildImplementation( unsigned, unsigned );
};



#endif
