#include <source/image/image_3D_array_rgb_char.hpp>


//********************IMPLEMENTATIONS*************************
bicotiImage3DArrayRGBChar :: bicotiImage3DArrayRGBChar(unsigned x0_size, unsigned x1_size, unsigned x2_size )
{
  ResetPointers();

  bicotiRGB< unsigned char, REAL > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation3DArray< bicotiRGB< unsigned char, REAL > >( def_pix, x0_size, x1_size, x2_size, 1, vectorial);
};


bicotiImage3DArrayRGBChar :: bicotiImage3DArrayRGBChar()
{
  ResetPointers();

  bicotiRGB< unsigned char, REAL > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation3DArray< bicotiRGB< unsigned char, REAL > >( def_pix, 0, 0, 0, 1, vectorial);
};


bicotiImage3DArrayRGBChar :: ~bicotiImage3DArrayRGBChar()
{
  DeleteMe();
};


void bicotiImage3DArrayRGBChar :: BuildImplementation( unsigned x0_size, unsigned x1_size, unsigned x2_size )
{
  DeleteMe();

  bicotiRGB< unsigned char, REAL > def_pix(0,0,0);
  
  ptr_implementation = new bicotiImageImplementation3DArray< bicotiRGB< unsigned char, REAL > >( def_pix, x0_size, x1_size, x2_size, 1, vectorial );
};

