#include <source/image/image_3D_linear_char.hpp>



//********************IMPLEMENTATIONS*************************
bicotiImage3DLinearChar :: bicotiImage3DLinearChar(unsigned x0_size, unsigned x1_size, unsigned x2_size)
{
  ResetPointers();

  ptr_implementation = new bicotiImageImplementation3DLinear< unsigned char >( 0, x0_size, x1_size, x2_size, 1, single);
};


bicotiImage3DLinearChar :: bicotiImage3DLinearChar()
{
  ResetPointers();

  ptr_implementation = new bicotiImageImplementation3DLinear< unsigned char >( 0, 0, 0, 0, 1, single);
};


bicotiImage3DLinearChar :: ~bicotiImage3DLinearChar()
{
  DeleteMe();
};


void bicotiImage3DLinearChar :: BuildImplementation( unsigned x0_size, unsigned x1_size, unsigned x2_size )
{
  DeleteMe();
  
  ptr_implementation = new bicotiImageImplementation3DLinear< unsigned char >( 0, x0_size, x1_size, x2_size, 1, single );
};

