#include <source/image/image_3D_linear_rgb_float.hpp>



//********************IMPLEMENTATIONS*************************
bicotiImage3DLinearRGBFloat :: bicotiImage3DLinearRGBFloat(unsigned x0_size, unsigned x1_size, unsigned x2_size )
{
  ResetPointers();

  bicotiRGB< float > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation3DLinear< bicotiRGB< float > >( def_pix, x0_size, x1_size, x2_size, 1, vectorial);
};


bicotiImage3DLinearRGBFloat :: bicotiImage3DLinearRGBFloat()
{
  ResetPointers();

  bicotiRGB< float > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation3DLinear< bicotiRGB< float > >( def_pix, 0, 0, 0, 1, vectorial);
};


bicotiImage3DLinearRGBFloat :: ~bicotiImage3DLinearRGBFloat()
{
  DeleteMe();
};


void bicotiImage3DLinearRGBFloat :: BuildImplementation( unsigned x0_size, unsigned x1_size, unsigned x2_size )
{
  DeleteMe();

  bicotiRGB< float > def_pix(0,0,0);
  
  ptr_implementation = new bicotiImageImplementation3DLinear< bicotiRGB< float > >( def_pix, x0_size, x1_size, x2_size, 1, vectorial );
};

