#include <source/interaction/interaction_file_dialog.hpp>


//------------------IMPLEMENTATIONS--------------------
//-----------bicotiInteractionSourceFileDialog-----
void bicotiInteractionSourceFileDialog :: AddListenerFileDialog( bicotiListenerFileDialog * ptr_listener )
{
  listener_file_dialog.push_back( ptr_listener );
}


void bicotiInteractionSourceFileDialog :: RemoveListenerFileDialog( bicotiListenerFileDialog * ptr_listener )
{
  vector< bicotiListenerFileDialog * > :: iterator iter;
  iter = find( listener_file_dialog.begin(), listener_file_dialog.end(), ptr_listener );
  listener_file_dialog.erase( iter );
}


void bicotiInteractionSourceFileDialog :: FireFileDialogFileSelected( bicotiActor * ptr_act, const char * file )
{
  for( int i = 0; i < listener_file_dialog.size(); i++ )
    listener_file_dialog[ i ]->FileDialogFileSelected( ptr_act, file );
}


void bicotiInteractionSourceFileDialog :: FireFileDialogFileHighlighted( bicotiActor * ptr_act, const char * file )
{
  for( int i = 0; i < listener_file_dialog.size(); i++ )
    listener_file_dialog[ i ]->FileDialogFileHighlighted( ptr_act, file );
}


void bicotiInteractionSourceFileDialog :: FireFileDialogDirectoryChanged( bicotiActor * ptr_act, const char * newdir )
{
  if( CheckCurrentDirectory( newdir ) )
    for( int i = 0; i < listener_file_dialog.size(); i++ )
      listener_file_dialog[ i ]->FileDialogDirectoryChanged( ptr_act, newdir );
}
