#include <source/interaction/interaction_process.hpp>

//------------------IMPLEMENTATTIONS-------------------
//------------bicotiInteractionSourceProcess-----------
void bicotiInteractionSourceProcess :: AddListenerProcess( bicotiListenerProcess * ptr_listener )
{listener_process.push_back( ptr_listener );}


void bicotiInteractionSourceProcess :: RemoveListenerProcess( bicotiListenerProcess * ptr_listener )
{
  vector< bicotiListenerProcess * > :: iterator iter;
  iter = find( listener_process.begin(), listener_process.end(), ptr_listener );
  listener_process.erase( iter );
}


void bicotiInteractionSourceProcess :: FireProcessStarted()
{
  for( int i=0; i<listener_process.size(); i++ )
    listener_process[i]->ProcessStarted();
}


void bicotiInteractionSourceProcess :: FireProcessStopped()
{
  for( int i=0; i<listener_process.size(); i++ )
    listener_process[i]->ProcessStopped();
}


