#ifndef _bicoti_interaction_process
#define _bicoti_interaction_process

#include <stl.h>

//--------------------DECLARATIONS---------------------
//-----------------bicotiEventProcess------------------
class bicotiEventProcess
{};


//-----------------bicotiListenerProcess---------------
class bicotiListenerProcess
{
public:
  virtual void ProcessStarted()=0;
  virtual void ProcessStopped()=0;
};


//------------bicotiInteractionSourceProcess-----------
class bicotiInteractionSourceProcess
{
protected:
  vector< bicotiListenerProcess * > listener_process;

public:
  void AddListenerProcess( bicotiListenerProcess * );
  void RemoveListenerProcess( bicotiListenerProcess * );
  
  void FireProcessStarted();
  void FireProcessStopped();
};



#endif
