#include <source/interaction/interaction_push_button.hpp>


//------------------IMPLEMENTATIONS--------------------
//-----------bicotiInteractionSourcePushButton-----
void bicotiInteractionSourcePushButton :: AddListenerPushButton( bicotiListenerPushButton * ptr_listener )
{listener_button.push_back( ptr_listener );}


void bicotiInteractionSourcePushButton :: RemoveListenerPushButton( bicotiListenerPushButton * ptr_listener )
{
  vector< bicotiListenerPushButton * > :: iterator iter;
  iter = find( listener_button.begin(), listener_button.end(), ptr_listener );
  listener_button.erase( iter );
}

void bicotiInteractionSourcePushButton :: FirePushButtonClicked( bicotiActor * ptr_act )
{
  for( int i=0; i<listener_button.size(); i++ )
    listener_button[i]->PushButtonClicked( ptr_act );
}
