//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _pixel_operator_binary_addition
#define _pixel_operator_binary_addition

#include <source/pixel/pixel_operator_binary_basic.hpp>



//**********************DECLARATIONS*******************************
//--------------bicotiPixelOperatorBinaryAddition------------------
template< class PixelType >
class bicotiPixelOperatorBinaryAddition : public bicotiPixelOperatorBinary< PixelType >
{
public:
  PixelType operator() ( PixelType, PixelType );
};



//*********************IMPLEMENTATIONS*****************************
//--------------bicotiPixelOperatorBinaryAddition------------------
template< class PixelType >
inline PixelType bicotiPixelOperatorBinaryAddition< PixelType > :: operator() ( PixelType pix_1, PixelType pix_2)
{
  return( (PixelType) (pix_1 + pix_2) );
};

#endif
