//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _pixel_operator_unary_absolute_value
#define _pixel_operator_unary_absolute_value

#include <source/pixel/pixel_operator_unary_basic.hpp>



//**********************DECLARATIONS*******************************
//---------------------------Abs-----------------------------------
template< class PixelType >
class bicotiPixelOperatorUnaryAbsoluteValue : public bicotiPixelOperatorUnary< PixelType >
{
public:
  PixelType operator() ( PixelType );
};



//*********************IMPLEMENTATIONS*****************************
//----------------------AbsoluteValue------------------------------
template<class PixelType> 
inline PixelType bicotiPixelOperatorUnaryAbsoluteValue< PixelType > :: operator() ( PixelType pix_val )
{
  return ( (PixelType) ( fabs( pix_val ) ) );
};

#endif
