#include <actor_image_2D_rgb_char_qt.hpp>
#include <actor.hpp> 
    
        
bicotiActorImage2DRGBCharQT :: HomologousFactory factory;  
 
class MyPanel : public bicotiActorGraphic2DPanel, public bicotiListenerPushButton  
{       
private: 
  bicotiActorImage2DRGBCharQT :: EventLoopManager * ptr_el;
 
  
  bicotiActorGraphic2DPushButton * ptr_boton_3;

  char nom1[10], nom2[10], nom3[10], nom4[10], nom5[10];
  char txt1[100], txt2[100], txt3[100], txt4[100], txt5[100];
 
public:
  MyPanel( bicotiActorImage2DRGBCharQT :: EventLoopManager * ptr_0,  char * nombre = NULL ) : bicotiActorGraphic2DPanel( nombre )
    {
      ptr_el = ptr_0;

      
      strcpy( nom3, "boton3" );
      
       
      
      strcpy( txt3, "Quit" );
  

      SetSize( 200, 300 );

  
      
      ptr_boton_3 = new bicotiActorGraphic2DPushButton( nom3 );
      SetChild( ptr_boton_3 );
      ptr_boton_3->SetPosition( 0, 200 );
      ptr_boton_3->SetSize( 200, 100 );
      ptr_boton_3->SetFont( bicotiFont( _times, 30, _bold ) );
      ptr_boton_3->SetText( txt3 );
      ptr_boton_3->AddListenerPushButton( this );

      }
 
  ~MyPanel()
    {}
  
  void PushButtonClicked( bicotiActor * ptr_boton )
    {
     
	  {if ( !strcmp( ptr_boton->GetActorDescriptor().GetActorName(), "boton3" ) )
	    {cout << "Saliendo de la aplicacion" << endl;
	    ptr_el->Stop();
	    }
	  }
    }

  void ActorResized( bicotiActor * ptr_ima, const bicotiEventGeometry& evento )
    {
      cout << "Me redimensionaron. Soy el actor: " << ptr_ima->GetActorDescriptor().GetActorName() << ". Ancho = " << evento.GetX() << ", alto = " << evento.GetY() << endl;
    }
  
  void ActorMoved( bicotiActor * ptr_ima, const bicotiEventGeometry& evento )
    {
      cout << "Me movieron. Soy el actor: " << ptr_ima->GetActorDescriptor().GetActorName() << ". X = " << evento.GetX() << ", Y = " << evento.GetY() << endl;
    }
 
  void MousePressed( bicotiActor * ptr_ima, const bicotiEventMouse& evento )
    {
      cout << "Me picaron. Soy el actor: " << ptr_ima->GetActorDescriptor().GetActorName() << ". X = " << evento.GetX() << ", Y = " << evento.GetY() << endl;
    }

  void MouseReleased( bicotiActor * ptr_ima, const bicotiEventMouse& evento )
    {
      cout << "Me despicaron. Soy el actor: " << ptr_ima->GetActorDescriptor().GetActorName() << ". X = " << evento.GetX() << ", Y = " << evento.GetY() << endl;
    }

  void MouseMoved( bicotiActor * ptr_ima, const bicotiEventMouseMotion& evento )
    {
      cout << "El mouse esta sobre el actor: " << ptr_ima->GetActorDescriptor().GetActorName() << "en X = " << evento.GetX() << ", Y = " << evento.GetY() << endl;
    }

  void TimerTic( bicotiActor * ptr_ima )
    {
      cout << "TIC" << endl;
    }
}; 



class MyReturn: public  bicotiListenerField
{

  bicotiActorGraphic2DLabel * myLabel; 
public:

  MyReturn(  bicotiActorGraphic2DLabel *ptr_label)
  {
    myLabel = ptr_label;
  }
 
  void FieldReturnPressed( bicotiActor * actor )
  {   
    cout << "Presion Return: " << ((bicotiActorGraphic2DField *)actor)->GetText() << endl;    
    ((bicotiActorGraphic2DField *)actor)->Clear(); 
        
  }   
 
  void FieldTextChanged( bicotiActor * actor )
    { 
      myLabel->SetText(((bicotiActorGraphic2DField *)actor)->GetText());
      cout << "modificado: " << ((bicotiActorGraphic2DField *)actor)->GetText() << endl;  
    }
}; 

void main( int argc, char **argv )  
{ 
 
  
  bicotiActorImage2DRGBCharQT :: EventLoopManager event_loop( argc, argv );
 
  MyPanel panel( &event_loop, "panel" );

  bicotiActorGraphic2DLabel label; 
 

  panel.SetChild(&label);   
  label.SetPosition(5,40);
  label.SetSize(80,50);
  label.SetFrame( true );
 
  bicotiActorGraphic2DField field; 
 
  field.SetFrame(false);
  field.SetEchoMode(EchoOn);
  field.SetCursorPosition(2);
 

  MyReturn cargoImagen(&label);
  field.AddListenerField( &cargoImagen );
  field.SetMaxLength(5);  
  panel.SetChild(&field);
  factory.RecursiveCreateHomologous( &panel );
  panel.SetPosition( 600, 100 );  
   
  
  field.SetPosition( 5, 5 ); 
  field.SetSize(100,30); 

  field.SetVisible(true); 
  field.SetText("hola"); 
  field.SelectAll();
    
  cout << "start" << endl;   
  event_loop.Start();    

};  

 
