#include "basic_settings.hpp"
#include "main_window.hpp"


void main( int argc, char ** argv )
{
  try
    {
      CurrentImageType :: EventLoopManager event_loop( argc, argv );
      MainWindow main_window( &event_loop );
      event_loop.Start();
    } 
  catch( bicotiException& excep )
    {
      cout << "Clase = " << excep.GetClassName() << ", funcion = " << excep.GetFunctionName() << endl;
    }
}
