#ifndef _bicoti_actor_graphic_menu_popup
#define _bicoti_actor_graphic_menu_popup


#include <source/actor/actor_graphic_menu.hpp>



//--------------------DECLARATIONS---------------------
//----------------bicotiActorGraphicMenu-----------------

/**
 *  Proporciona un men desplegable.
 *
 * Un bicotiActorGraphicMenuPopup puede contener varios tems y otros bicotiActorGraphicMenuPopup asociados a los mismos as como separadores. El ancho, la altura y la posicin del men se ajustan automticamente. Es fuente de eventos de menu.
 *@see bicotiHomologousGraphicMenuPopup
 */
class bicotiActorGraphicMenuPopup : public bicotiActorGraphicMenu
{
public:

  /**
   * Constructor.
   *
   *@param  act_name nombre del actor.
   */
 bicotiActorGraphicMenuPopup( char * act_name = NULL );
 
  /** Destructor */  
 virtual ~bicotiActorGraphicMenuPopup();
};


//-----------------bicotiHomologousMenuPopup------------------

/** Homlogo del bicotiActorGraphicMenuPopup. 
 *
 *@see bicotiActorGraphicMenuPopup
 */
class bicotiHomologousGraphicMenuPopup : public bicotiHomologousGraphicMenu
{
public:
 
  /** Destructor */
 virtual ~bicotiHomologousGraphicMenuPopup();
};



#endif
