#include <source/event_loop_manager/qt/homologous_qt_menu_popup.hpp>
#include <iostream.h>

//-----------------bicotiQTMenuPopup------------------
bicotiQTMenuPopup :: bicotiQTMenuPopup( QWidget * parent, const char * name ) : QPopupMenu( parent, name )
{
  hide();
  ptr_actor = NULL;
  connect( this, SIGNAL(activated( int )), this, SLOT(Selected( int )) );
}

bicotiQTMenuPopup :: ~bicotiQTMenuPopup()
{
  recreate( NULL, 0, QPoint( x(), y() ) , false );
}


void bicotiQTMenuPopup :: Selected( int id )
{
  bicotiActorGraphicMenu * ptr_local_actor = ((bicotiActorGraphicMenu*)ptr_actor);
  
  if( ptr_local_actor->CheckItem( id ) )
    ptr_local_actor->FireItemSelected( ptr_actor, ptr_local_actor->GetItem( id ) );
}



#define bicotiLocalTemplate
#define bicotiLocalClass bicotiQTMenuPopup
#include <source/event_loop_manager/qt/homologous_qt_graphic.cpp>
#include <source/event_loop_manager/qt/homologous_qt_graphic_menu.cpp>
