#ifndef _bicoti_homologous_qt_menu_popup
#define _bicoti_homologous_qt_menu_popup



#include <qpopupmenu.h>
#include <source/actor/actor_graphic_2D.hpp>
#include <source/actor/actor_graphic_menu_popup.hpp>
#include <source/event_loop_manager/qt/homologous_qt_caster.hpp>


//-----------------bicotiQT2DPushButton------------------

/** Implementacin QT de bicotiHomologousGraphicMenuPopup */
class bicotiQTMenuPopup :  public QPopupMenu, public bicotiHomologousGraphicMenuPopup
{
/**@#-*/
Q_OBJECT
/**@#+*/


public /**@#-*/ slots /**@#+*/ :

/** 
 * Slot: se ejecuta cuando se selecciona un item del men.
 *
 *@param id identificador del item seleccionado
 */
void Selected( int id );

public:
  
  /**
   * Constructor 
   *
   *@param parent widget padre
   *@param name nombre del homlogo
   */
  bicotiQTMenuPopup( QWidget * parent=0, const char * name=0 );
 
  /** Destructor */
  ~bicotiQTMenuPopup();

#include <source/event_loop_manager/qt/homologous_qt_graphic.hpp>
#include <source/event_loop_manager/qt/homologous_qt_graphic_menu.hpp>
};


#endif
