//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################




#ifndef _image_2D_array_hsv_int
#define _image_2D_array_hsv_int



#include <source/image/image_2D_vectorial.hpp>
#include <source/pixel/pixel_converter_rgba.hpp>



//**********************DECLARATIONS**************************
class bicotiImage2DArrayHSVInt : public bicotiImage2DVectorial< bicotiImageImplementation2DArray< bicotiHSV< unsigned int, REAL > >, unsigned int, bicotiPixelConverterHSVInt2RGBA, bicotiHSV< unsigned int, REAL >, bicotiHSV< REAL, unsigned int > >
{
public:
  bicotiImage2DArrayHSVInt( unsigned, unsigned );
  bicotiImage2DArrayHSVInt();
  ~bicotiImage2DArrayHSVInt();

  void BuildImplementation( unsigned, unsigned );
  void BuildMapper();
};


#endif
