#include <source/image/image_3D_array_float.hpp>

//********************IMPLEMENTATIONS*************************
bicotiImage3DArrayFloat :: bicotiImage3DArrayFloat(unsigned x0_size, unsigned x1_size, unsigned x2_size )
{
  ResetPointers();
  
  ptr_implementation = new bicotiImageImplementation3DArray< float >( 0, x0_size, x1_size, x2_size, 1, single );
};


bicotiImage3DArrayFloat :: bicotiImage3DArrayFloat()
{
  ResetPointers();

  ptr_implementation = new bicotiImageImplementation3DArray< float >( 0, 0, 0, 0, 1, single );
};


bicotiImage3DArrayFloat :: ~bicotiImage3DArrayFloat()
{
  DeleteMe();
};


void bicotiImage3DArrayFloat :: BuildImplementation( unsigned x0_size, unsigned x1_size, unsigned x2_size )
{
  DeleteMe();

  ptr_implementation = new bicotiImageImplementation3DArray< float >( 0, x0_size, x1_size, x2_size, 1, single );
};
