#include <source/image/image_3D_array_rgb_float.hpp>



//********************IMPLEMENTATIONS*************************
bicotiImage3DArrayRGBFloat :: bicotiImage3DArrayRGBFloat(unsigned x0_size, unsigned x1_size, unsigned x2_size )
{
  ResetPointers();

  bicotiRGB< float > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation3DArray< bicotiRGB< float > >( def_pix, x0_size, x1_size, x2_size, 1, vectorial);
};


bicotiImage3DArrayRGBFloat :: bicotiImage3DArrayRGBFloat()
{
  ResetPointers();

  bicotiRGB< float > def_pix(0,0,0);

  ptr_implementation = new bicotiImageImplementation3DArray< bicotiRGB< float > >( def_pix, 0, 0, 0, 1, vectorial);
};


bicotiImage3DArrayRGBFloat :: ~bicotiImage3DArrayRGBFloat()
{
  DeleteMe();
};


void bicotiImage3DArrayRGBFloat :: BuildImplementation( unsigned x0_size, unsigned x1_size, unsigned x2_size )
{
  DeleteMe();

  bicotiRGB< float > def_pix(0,0,0);
  
  ptr_implementation = new bicotiImageImplementation3DArray< bicotiRGB< float > >( def_pix, x0_size, x1_size, x2_size, 1, vectorial );
};


