//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _image_extrapolation_strategy_2D 
#define _image_extrapolation_strategy_2D 

 
 
#include <source/image_implementation/image_extrapolation_strategy_basic.hpp>

 
 
//***********************************DECLARATIONS*********************************************
//-------------------------bicotiImageExtrapolationStrategy2D---------------------------------
template< class PixelType >  
class bicotiImageImplementation2D;


template< class PixelType >  
class bicotiImageExtrapolationStrategy2D : public bicotiImageExtrapolationStrategy< PixelType > 
{ 
protected: 
  bicotiImageImplementation2D< PixelType > * ptr_image; 
   
public: 
  virtual ~bicotiImageExtrapolationStrategy2D(){}; 

  void SetImplementation( bicotiImageImplementation2D< PixelType > * ); 
  virtual PixelType operator() ( int, int ) = 0; 
}; 
 
 
 
 
//*********************************IMPLEMENTATIONS********************************************
//-------------------------bicotiImageExtrapolationStrategy2D---------------------------------
template< class PixelType >  
void bicotiImageExtrapolationStrategy2D< PixelType > :: SetImplementation( bicotiImageImplementation2D< PixelType > * ptr_ima ) 
{ 
  ptr_image = ptr_ima; 
}; 


#endif                      
