//###########################################################
//#            Proyecto de fin de carrera BICOTI-I          #
//#   BIblioteca de COmponentes de Tratamiento de Imgenes  #
//#             Instituto de Ingeniera Elctrica           #
//#   Desarrollado por:                                     #
//#                     Claudio Risso                       #
//#                     Rodolfo Rodriguez                   #
//#                     Alvaro Valdes                       #
//#                                                         #
//#   Director:                                             #
//#                     Pablo Darscht                       #
//#                                                         #
//#   Asesoramiento en Tratamiento de Imgenes:             #
//#                     Alicia Fernandez                    #
//#                     Gregory Randall                     #
//#                                                         #
//#   Thanks To:                                            #
//#                     Hans Schmid                         #
//#                     Alberto Bartesaghi                  #
//#                     Facundo Memoli                      #
//#                     Alvaro Gomez                        #
//#                     Leonardo Steinfield                 #
//#                                                         #
//###########################################################


#ifndef _pixel_weight_none
#define _pixel_weight_none

#include <source/pixel/pixel_weight_basic.hpp>



//*************************DECLARATIONS****************************
template< class PixelType >
class bicotiPixelWeightNone : public bicotiPixelWeight< PixelType >
{
public:
  double operator() ( PixelType );
};



//***********************IMPLEMENTATIONS***************************
template< class PixelType >
inline double bicotiPixelWeightNone< PixelType > :: operator() ( PixelType pixel )
{
  return( 1 );
};

#endif
